# -*- coding: utf-8 -*
import os

from flyai.utils.yaml_helper import Yaml


class Base(object):

    def __init__(self, dataset):
        self.dataset = dataset
        self.yaml = Yaml()

    def predict(self, path, data, name, keep=""):
        '''
        使用模型
        :param path: 模型所在的路径
        :param data: 输入的数据
        :param name: 模型的名字
        :param keep: 模型的keep_prod
        :return: 返回预测的类型
        '''
        pass

    def evaluate(self, path, name):
        '''
        验证模型
        :param path: 模型的路径
        :param name: 模型的名字
        :return: 返回验证的准确率
        '''
        pass

    def save_model(self, session, path, name, overwrite=False):
        '''
        保存模型
        :param session: 训练模型的sessopm
        :param path: 要保存模型的路径
        :param name: 要保存模型的名字
        :param overwrite: 是否覆盖当前模型
        :return:
        '''
        self.check(path, overwrite)

    def check(self, path, overwrite=False):
        '''
        检测模型路径是否存在，是否被覆盖
        :param path: 要保存的路径
        :param overwrite: 是否覆盖
        :return:
        '''
        if overwrite:
            for root, dirs, files in os.walk(path, topdown=False):
                for name in files:
                    os.remove(os.path.join(root, name))
                for name in dirs:
                    os.rmdir(os.path.join(root, name))
        if not os.path.exists(path):
            os.makedirs(path)
