# encoding=utf-8

import jieba
import json
import os


def seg_for_file(save_path, file_name, thread=4):
    if not os.path.exists(save_path):
        os.makedirs(save_path)
    seg_list = []
    i = 0
    with open(file_name) as fh:
        for line in fh:
            print(line)
            segs = jieba.cut(line, cut_all=False)
            jieba.enable_parallel(thread)
            for seg in segs:
                seg_list.append(seg)
            i += 1
    seg_list = list(set(seg_list))
    f = open(os.path.join(save_path, "words.json"), mode='w')
    f.write(json.dumps(seg_list))
    return seg_list


def make_embedding_for_json(save_path, seg_list, embedding_path=os.path.join('data', 'embedding')):
    if not os.path.exists(save_path):
        os.makedirs(save_path)
    embeddin_map = {}
    f = open(embedding_path, encoding='utf8', mode='r')
    embedding_index = json.loads(f.read())
    for seg in seg_list:
        try:
            embeddin_map[seg] = embedding_index[seg]
        except KeyError:
            embeddin_map[seg] = "nan"
    f = open(os.path.join(save_path, "embedding.json"), encoding='utf-8', mode='w')
    f.write(json.dumps(embeddin_map))
